******************************************************************************
* KEYPAD.PRG - Keypad simulation v1.00
*
* This program will work from the command window of FOXPROW (Windows version)
*
* Displays a keyboard and accepts user input by mouse click.
* Typically, this program will be called by another program.
* The user input is stored in the variable 'chstr' and can be accessed by
* this name in the calling program.
* Although a keypad is not required but if one is connected then it will be
* functional as normal.
*
* Written by:Mr.M.K.Loyalka
* Address   :Ratnakar, N.D.Road, Mumbai 400 006, INDIA.
* Telephone :Res:(0091)(22)369-5057
*           :Off:(0091)(22)284-5223
* email     :sloyalka@rediffmail.com
*
* SYNTAX - do keypad
*
* FREE!!! - I wrote this program for my own use and am releasing
* it into puplic domain on the following conditions.
* - If you use it, PLEASE let me know. (It's nice to know that
* others find your work useful.)
* - A thank-you gift of US$10 would be appreciated if you find that
* you are frequently using this code either un-modified or
* as a base for other code. (HOWEVER, IT IS NOT REQUIRED!)
* - I must get credit for this code if used in any publication.
* - My name must not be removed from the comments of this code
* as the original writer.
* - If you release any updated/revised version, you must add
* to these comments. Include your name and a summary
* of what you have fixed/added. (Please, send me a copy of
* the updated code.)
*
****************************************************************************
set talk off
set escape off
clear
public [array] moustr(10,27),w1(13)
chstr=''
push key clear
row1=row()
col1=col()
*************************************
set color of scheme 1 to rgb(255,0,0,255,255,255) && red on white
set color of scheme 2 to rgb(0,0,0,255,255,255)   && black on white
set color of scheme 3 to rgb(0,0,255,255,255,255) && blue on white
set color of scheme 4 to rgb(255,0,0,255,255,0)   && red on yellow
set color of scheme 5 to rgb(255,0,0,0,255,255)   && red on cyan
****************************************************
*** Create and open a window ***
define window keypad at 17,54 size 10,26 title 'Keyboard' float grow zoom panel font 'fixedsys',15 color rgb(0,0,255,255,255,0)
activate window keypad
****************************
w=97
m=1
for u=1 to 2
  z=1
  for v=1 to 13
    for y=z to z+2
      for x=m to m+1
        moustr(x,y)=chr(w)
      next
    next
    w=w+1
    z=z+2
  next
  m=m+1
next
****************************
****************************
w=65
m=3
for u=1 to 2
  z=1
  for v=1 to 13
    for y=z to z+2
      for x=m to m+1
        moustr(x,y)=chr(w)
      next
    next
    w=w+1
    z=z+2
  next
  m=m+1
next
****************************
****************************
w=1
w1(1)=43
w1(2)=45
w1(3)=42
w1(4)=47
w1(5)=38
w1(6)=44
w1(7)=46
w1(8)=39
w1(9)=61
w1(10)=40
w1(11)=41
w1(12)=64
w1(13)=63
m=5
z=1
for v=1 to 13
  for y=z to z+2
    for x=m to m+1
      moustr(x,y)=chr(w1(w))
    next
  next
  w=w+1
  z=z+2
next
****************************
w=1
w1(1)=92
w1(2)=37
w1(3)=62
w1(4)=60
w1(5)=33
w1(6)=163
w1(7)=36
w1(8)=95
w1(9)=123
w1(10)=125
w1(11)=91
w1(12)=93
w1(13)=35
m=6
z=1
for v=1 to 13
  for y=z to z+2
    for x=m to m+1
      moustr(x,y)=chr(w1(w))
    next
  next
  w=w+1
  z=z+2
next
****************************
w=1
w1(1)=126
w1(2)=58
w1(3)=34
w1(4)=124
w1(5)=96
w1(6)=172
w1(7)=46
w1(8)=32
w1(9)=32
w1(10)=32
w1(11)=32
w1(12)=32
w1(13)=32
m=7
z=1
for v=1 to 13
  for y=z to z+2
    for x=m to m+1
      moustr(x,y)=chr(w1(w))
    next
  next
  w=w+1
  z=z+2
next
****************************
w=48
m=8
for u=1 to 2
  z=1
  for v=1 to 5
    for y=z to z+4
      for x=m to m+1
        moustr(x,y)=chr(w)
      next
    next
    w=w+1
    z=z+4
  next
  m=9
next
****************************
for y=21 to 26
  for x=8 to 9
    moustr(x,y)='ba'
  next
next
****************************
for y=21 to 26
  for x=9 to 10
    moustr(x,y)='en'
  next
next
****************************
y=97
for x=.4 to 26 step 2
  @ 0,x say chr(y) color rgb(255,0,0,255,255,0)
  y=y+1
next
y=110
for x=.4 to 26 step 2
  @ 1,x say chr(y) color rgb(255,0,0,255,255,0)
  y=y+1
next
**********************
y=65
for x=.4 to 26 step 2
  @ 2,x say chr(y) color rgb(0,0,255,255,255,0)
  y=y+1
next
y=78
for x=.4 to 26 step 2
  @ 3,x say chr(y) color rgb(0,0,255,255,255,0)
  y=y+1
next
**********************
@ 7,0 say space(20) color rgb(255,0,0,0,255,255)
@ 8,0 say space(20) color rgb(255,0,0,0,255,255)
@ 6,20 say space(6) color rgb(255,0,0,0,255,255)
y=48
for x=1 to 20 step 4
  @ 7,x+.4 say chr(y) color rgb(255,0,0,0,255,255)
  y=y+1
next
y=53
for x=1 to 20 step 4
  @ 8,x+.4 say chr(y) color rgb(255,0,0,0,255,255)
  y=y+1
next
**********************
@ 6,20.5 say 'Space' color rgb(255,0,0,0,255,255)
@ 7,20.1 say 'BackSp'
@ 8,20.5 say 'ENTER'
**********************
@ 4,0 say space(26) color rgb(255,0,0,255,255,0)
@ 4,0.4 say chr(43) color rgb(255,0,0,255,255,0)
@ 4,2.4 say chr(45) color rgb(255,0,0,255,255,0)
@ 4,4.4 say chr(42) color rgb(255,0,0,255,255,0)
@ 4,6.4 say chr(47) color rgb(255,0,0,255,255,0)
@ 4,8.4 say chr(38) color rgb(255,0,0,255,255,0)
@ 4,10.4 say chr(44) color rgb(255,0,0,255,255,0)
@ 4,12.4 say chr(46) color rgb(255,0,0,255,255,0)
@ 4,14.4 say chr(39) color rgb(255,0,0,255,255,0)
@ 4,16.4 say chr(61) color rgb(255,0,0,255,255,0)
@ 4,18.4 say chr(40) color rgb(255,0,0,255,255,0)
@ 4,20.4 say chr(41) color rgb(255,0,0,255,255,0)
@ 4,22.4 say chr(64) color rgb(255,0,0,255,255,0)
@ 4,24.4 say chr(63) color rgb(255,0,0,255,255,0)
*******************************************
@ 5,0 say space(26) color rgb(255,0,0,255,255,0)
@ 5,0.4 say chr(92) color rgb(255,0,0,255,255,0)
@ 5,2.4 say chr(37) color rgb(255,0,0,255,255,0)
@ 5,4.4 say chr(62) color rgb(255,0,0,255,255,0)
@ 5,6.4 say chr(60) color rgb(255,0,0,255,255,0)
@ 5,8.4 say chr(33) color rgb(255,0,0,255,255,0)
@ 5,10.4 say chr(163) color rgb(255,0,0,255,255,0)
@ 5,12.4 say chr(36) color rgb(255,0,0,255,255,0)
@ 5,14.4 say chr(95) color rgb(255,0,0,255,255,0)
@ 5,16.4 say chr(123) color rgb(255,0,0,255,255,0)
@ 5,18.4 say chr(125) color rgb(255,0,0,255,255,0)
@ 5,20.4 say chr(91) color rgb(255,0,0,255,255,0)
@ 5,22.4 say chr(93) color rgb(255,0,0,255,255,0)
@ 5,24.4 say chr(35) color rgb(255,0,0,255,255,0)
*******************************************
@ 6,0 say space(20) color rgb(255,0,0,255,255,0)
@ 6,0.4 say chr(126) color rgb(255,0,0,255,255,0)
@ 6,2.4 say chr(58) color rgb(255,0,0,255,255,0)
@ 6,4.4 say chr(34) color rgb(255,0,0,255,255,0)
@ 6,6.4 say chr(124) color rgb(255,0,0,255,255,0)
@ 6,8.4 say chr(96) color rgb(255,0,0,255,255,0)
@ 6,10.4 say chr(172) color rgb(255,0,0,255,255,0)
@ 6,12.4 say chr(46) color rgb(255,0,0,255,255,0)
*******************************************
for x=1 to 9
  @ x,0 to x,26
next
for x=2 to 20 step 2
  @ 0,x to 7,x
next
for x=20 to 26 step 2
  @ 0,x to 6,x
next
@ 0,26 to 10,26
for x=4 to 20 step 4
  @ 0,x to 9,x
next
*****************************
@ 6,14 say 'ESCAPE' color rgb(0,0,0,255,0,0)
****************************
for y=15 to 20
  for x=7 to 7
    moustr(x,y)='es'
  next
next
****************************
@ 9,.2 say ''
inval1 = 0
*** Main program loop ***
do while .t.
  inval1 = inkey('M')
  if inval1 = 0
    loop
  endif
  if inval1 = 27
    exit
  endif
  if inval1 = 151
    row = mrow()
    col = mcol()
    if col != -1 and row != -1
      if 'es'$moustr(row+1,col+1)
        chstr=''
        exit
      endif
      if 'en'$moustr(row+1,col+1)
        clear typeahead
        keyboard chstr
        @ row1,col1 say ''
        deactivate window keypad
        pop key
        exit
      endif
      if 'ba'$moustr(row+1,col+1)
        chstr=substr(chstr,1,len(chstr)-1)
      else
        if row<9
          chstr=chstr+moustr(row+1,col+1)
        endif
      endif
      @ 9.1,0 clear
      @ 9.1,0 say chstr

    endif

    if col = -1 or row = -1
      loop
    endif
  endif
  *** Keyboard character pressed ***
  if inval1 # 151 and between(inval1, 0, 256) && Good CHR() value
    if inval1=13
      clear typeahead
      keyboard chstr
      @ row1,col1 say ''
      deactivate window keypad
      pop key
      exit
    endif
    if inval1=22.or.inval1=1.or.inval1=7.or.inval1=6.or.inval1=18.or.inval1=3
      loop
    endif
    if inval1=5.or.inval1=24.or.inval1=4.or.inval1=19.or.inval1=9.or.inval1=28.or.inval1=133.or.inval1=134
      loop
    endif
    if inval1=127
      chstr=substr(chstr,1,len(chstr)-1)
    else
      chstr=chstr+chr(inval1)
    endif
    @ 9.1,0 clear
    @ 9.1,0 say chstr
  endif
enddo  	End of Main loop
*** Restore original environment ***
set talk on
set escape on
clear windows
return
